<?php
$zing_forum_name = "Zingiri Forum";
$zing_forum_shortname = "zing_forum";
$zing_login_type = array("WP","MyBB");

$zing_forum_options[] = array(  "name" => "Zingiri Forum Settings",
            "type" => "heading",
			"desc" => "This section customizes the Zingiri Forum area.");
$zing_forum_options[] = array(	"name" => "Type of integration",
			"desc" => "Select the way you and your users want to login. In WP mode, your users will only need to login once<br />
			to have access to the forum. In MyBB mode, users in your blog and in your forum are independent.<br />
If it's your first time logging in( MyBB mode), you can use user <strong>admin</strong> with password <strong>admin</strong>.",
			"id" => $zing_forum_shortname."_login",
			"std" => "WP",
			"type" => "select",
			"options" => $zing_login_type);
$zing_forum_options[] = array(	"name" => "MyBB admin password",
			"desc" => "If not using the Wordpress user integration, specify the password of the MyBB admin user,<br />this will be used to easily upgrade your system and for other housekeeping tasks.<br />",
			"id" => $zing_forum_shortname."_admin_password",
			"std" => 'admin',
			"type" => "text");

function zing_forum_add_admin() {

	global $zing_forum_name, $zing_forum_shortname, $zing_forum_options;

	if ( $_GET['page'] == "zingiri-forum-cp" ) {

		if ( 'install' == $_REQUEST['action'] ) {
			foreach ($zing_forum_options as $value) {
				update_option( $value['id'], $_REQUEST[ $value['id'] ] );
			}

			foreach ($zing_forum_options as $value) {
				if( isset( $_REQUEST[ $value['id'] ] ) ) {
					update_option( $value['id'], $_REQUEST[ $value['id'] ]  );
				} else { delete_option( $value['id'] );
				}
			}
			zing_forum_install();
			
			if (get_option("zing_forum_login")=="WP") {
//error_reporting(E_ALL & ~E_NOTICE);
//ini_set('display_errors', '1');
				
				require_once(dirname(__FILE__).'/includes/wpusers.class.php');
				$wpusers=new wpusers();
				$wpusers->sync();
				//print_r($wpusers->getWpUsers());
//				die('ok');
			}
			header("Location: options-general.php?page=zingiri-forum-cp&installed=true");
			die;
		}

		if( 'uninstall' == $_REQUEST['action'] ) {
			zing_forum_uninstall();
			foreach ($zing_forum_options as $value) {
				delete_option( $value['id'] );
				update_option( $value['id'], $value['std'] );
			}
			header("Location: options-general.php?page=zingiri-forum-cp&uninstalled=true");
			die;
		}
	}

	add_options_page($zing_forum_name." Options", "$zing_forum_name", 8, basename(__FILE__), 'zing_forum_admin');
	add_menu_page($zing_forum_name, $zing_forum_name, 'administrator', 'zingiri-forum-cp','zing_forum_admin');
	add_submenu_page('zingiri-forum-cp', $zing_forum_name.'- Integration', 'Integration', 'administrator', 'zingiri-forum-cp', 'zing_forum_admin');
	add_submenu_page('zingiri-forum-cp', $zing_forum_name.'- Administration', 'Administration', 'administrator', 'zingiri-forum-admin', 'zing_mybb_admin');
	
}

function zing_mybb_admin() {
	global $zing_forum_mode;
	global $zing_forum_content;
	//global $zing_forum_menu;
	
	$zing_forum_mode="admin";
	if (!$_GET['zforumadmin']) $_GET['zforumadmin']='index';
	//zing_forum_login_user();
	echo '<div style="width:80%;">';
	if (get_option("zing_forum_login")=="WP") zing_forum_login_admin();
	//print_r($_SERVER);
	zing_forum_header();
	//if ($zing_forum_content=='redirect') {
	//	header('Location:'.get_option('home').'/?page_id='.zing_forum_mainpage());
	//	die();
	//} else {
		echo $zing_forum_content;
	//}
	echo '</div>';
	
}
function zing_forum_admin() {

	global $zing_forum_name, $zing_forum_shortname, $zing_forum_options;
	error_reporting(E_ALL & ~E_NOTICE);
	ini_set('display_errors', '1');

	if ( $_REQUEST['installed'] ) echo '<div id="message" class="updated fade"><p><strong>'.$zing_forum_name.' installed.</strong></p></div>';
	if ( $_REQUEST['uninstalled'] ) echo '<div id="message" class="updated fade"><p><strong>'.$zing_forum_name.' uninstalled.</strong></p></div>';

	?>
<div class="wrap">
<h2><b><?php echo $zing_forum_name; ?></b></h2>

	<?php
	$zing_ew=zing_forum_check();
	$zing_errors=$zing_ew['errors'];
	$zing_warnings=$zing_ew['warnings'];
	if ($zing_errors) {
		echo '<div style="background-color:pink" id="message" class="updated fade"><p>';
		echo '<strong>Errors - you need to resolve these errors before continuing:</strong><br /><br />';
		foreach ($zing_errors as $zing_error) echo $zing_error.'<br />';
		echo '</p></div>';
	}
	if ($zing_warnings) {
		echo '<div style="background-color:peachpuff" id="message" class="updated fade"><p>';
		echo '<strong>Warnings - you might want to have a look at these issues to avoid surprises or unexpected behaviour:</strong><br /><br />';
		foreach ($zing_warnings as $zing_warning) echo $zing_warning.'<br />';
		echo '</p></div>';
	}
	$zing_forum_version=get_option("zing_forum_version");
	if (empty($zing_forum_version)) {
		echo 'Please proceed with a clean install or deactivate your plugin';
		$submit='Install';
	} elseif ($zing_forum_version != ZING_FORUM_VERSION) {
		echo 'You downloaded version '.ZING_FORUM_VERSION.' and need to upgrade your database (currently at version '.$zing_forum_version.').';
		$submit='Upgrade';
	} elseif ($zing_forum_version == ZING_FORUM_VERSION) {
		echo 'Your version is up to date!';
		$submit='Update';
	}
	
	if (count($zing_errors)==0) {
	?> 
<form method="post">

<table class="optiontable">

<?php if ($zing_forum_options) foreach ($zing_forum_options as $value) {

	if ($value['type'] == "text") { ?>

	<tr align="left">
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td><input name="<?php echo $value['id']; ?>"
			id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>"
			value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>"
			size="40" /></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "textarea") { ?>
	<tr align="left">
		<th scope="row"><?php echo $value['name']; ?>:</th>
		<td><textarea name="<?php echo $value['id']; ?>"
			id="<?php echo $value['id']; ?>" cols="50" rows="8" />
			<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes (get_settings( $value['id'] )); }
			else { echo $value['std'];
			} ?>
</textarea></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "select") { ?>

	<tr align="left">
		<th scope="top"><?php echo $value['name']; ?>:</th>
		<td><select name="<?php echo $value['id']; ?>"
			id="<?php echo $value['id']; ?>">
			<?php foreach ($value['options'] as $option) { ?>
			<option
			<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; }?>><?php echo $option; ?></option>
			<?php } ?>
		</select></td>

	</tr>
	<tr>
		<td colspan=2><small><?php echo $value['desc']; ?> </small>
		<hr />
		</td>
	</tr>

	<?php } elseif ($value['type'] == "heading") { ?>

	<tr valign="top">
		<td colspan="2" style="text-align: left;">
		<h2 style="color: green;"><?php echo $value['name']; ?></h2>
		</td>
	</tr>
	<tr>
		<td colspan=2><small>
		<p style="color: red; margin: 0 0;"><?php echo $value['desc']; ?></P>
		</small>
		<hr />
		</td>
	</tr>

	<?php } ?>
	<?php
}
?>
</table>

<p class="submit"><input name="install" type="submit" value="<?php echo $submit;?>" />
<input type="hidden" name="action" value="install" /></p>
</form>
<?php }?>
<?php if ($zing_forum_version) { ?>
</form>
<hr />
<form method="post">
<p class="submit"><input name="uninstall" type="submit"
	value="Uninstall" /> <input type="hidden" name="action"
	value="uninstall" /></p>
</form>
<?php } ?>
<hr />
	<img src="<?php echo ZING_FORUM_URL?>/zingiri-logo.png" height="50px" />
<p>For more info and support, contact us at <a
	href="http://www.zingiri.com">Zingiri</a> or check out our <a
	href="http://forums.zingiri.com">support forums</a>.</p>
<?php
}
add_action('admin_menu', 'zing_forum_add_admin'); ?>